<template>
  <div class="mx-auto app__wrapper-container">
    <banner-mobile v-if="$route.fullPath.includes('games')"
      :theme-properties="themeProperties"
      :actived="'GameInitial'"
      class="mobileBannerCarouselBfm1 pb-2 px-2"
    />
    <div class="w-full black-flexible1-customize">
      <lobby-playful-entry-filter class="game-entry-filter px-2"
        :menus="gameEntryTabMenus"
        v-model:search="searchedGame"
        @onFilterClicked="onFilter"
        @search-games="updateSearchResult"
      />
      <div class="pt-4 px-2 plf-game-container" v-if="!isFilterAllGames">
        <lobby-render
          :loading="isLoading"
          :games="gameCollection"
          :isHasGroupTitle="true"
          :groupTitle="gameGroupTitle"
          classGameName="text-white"
          :show-staus="true"
          :grid="3"
          :showGameName="false"
        />
      </div>
      <!-- <game-entry v-if="themeColor.Text.includes('playful') && !isFilterAllGames" class="mGameEntry" /> -->
      <lobby-render-all-games v-else
        :loading="isLoading"
        :games="gameCollection"
        :isHasGroupTitle="true"
        :groupTitle="gameGroupTitle"
        classGameName="text-white"
        :show-staus="true"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import { useGameEntryComponent } from "@/composables/useTheme";
import { IGameEntryMenu, TabGameMenu } from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";
import { store } from "~~/store";

export default defineComponent({
  setup() {
    const {
      isLoading,
      headerTab,
      initialGameEntry,
      searchedGame,
      handleSearchGame,
      getGameEntryFiltered,
      gameCollection,
      updateSearchResult,
      isFilterAllGames,
      playableGame,
    } = useGameEntryComponent();
    const gameEntryTabMenus = computed(() => {
      const result: IGameEntryMenu[] = [
        {
          Menus: headerTab.value.map((item) => new TabGameMenu(item, "main")),
          IsSearchBox: false,
          Justify: "left",
          Theme: "common",
        },
        {
          Menus: [],
          IsSearchBox: true,
          Justify: "left",
          Theme: "main",
        },
      ];
      return result;
    });

    const gameGroupTitle = ref("Top Games");
    const onFilter = (request: GameFilterRequest) => {
      getGameEntryFiltered(request);
      gameGroupTitle.value =
        request.Value === "" ? request.Type : request.Value;
    };
    watch(
      () => searchedGame.value,
      () => {
        handleSearchGame();
      }
    );
    const { themeColor } = themePropertyHelper;
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const route = useRoute();
    const isGamePage = computed(() => route.matched[0].name === "games");
    return {
      gameEntryTabMenus,
      searchedGame,
      onFilter,
      initialGameEntry,
      gameGroupTitle,
      isLoading,
      gameCollection,
      updateSearchResult,
      isFilterAllGames,
      themeColor,
      themeProperties,
      isGamePage,
      playableGame,
    };
  },
});
</script>
<style lang="scss">
:root {
  --gf-background-color: var(--border);
  --new-text-color: white;
  --gf-text-active-color: white;
}
[layout="playful"][data-device="mobile"] {
  .plf-game-container {
    padding-top: 0 !important;
  }
}
.black-flexible1-customize {
  .game-filter-bg {
    background-color: transparent;
  }
  position: relative;
  .grid.grid-cols-10 {
    grid-template-columns: repeat(12, minmax(0, 1fr));
  }
  .game-filter {
    margin-bottom: 15px;
  }
  .grid {
    margin-bottom: 15px;
    .col-span-2 {
      border: none;
      .cursor-pointer div {
        justify-content: center;
        // height: 38px;
      }
      .cursor-pointer img {
        width: 100%;
      }
    }
  }
  .grid .flex .flex {
    .game-tab-menu .flex {
      flex-direction: row;
      margin-bottom: 8px;
      .game-tab-icon,
      .game-tab-icon-active {
        width: 1.25rem;
        height: auto;
      }
    }
    span {
      color: white;
    }
  }
  div .w-full.text-white {
    display: none;
  }
}
</style>
